# HG changeset patch
# User Valentin Bartenev <vbart@nginx.com>
# Date 1363011730 -14400
# Node ID 8be96294e4defb89b36256f8b22ef09eb603dea6
# Parent  b8702a990706f5e4f99f9ffc27aef082bcf15cb4
Allow to reuse connections that wait their first request.

This should improve behavior under deficiency of connections.

diff -r b8702a990706 -r 8be96294e4de src/http/ngx_http_request.c
--- a/src/http/ngx_http_request.c	Mon Mar 11 17:55:34 2013 +0400
+++ b/src/http/ngx_http_request.c	Mon Mar 11 18:22:10 2013 +0400
@@ -354,6 +354,8 @@ ngx_http_init_connection(ngx_connection_
         return;
     }
 
+    ngx_reusable_connection(c, 1);
+
     ngx_add_timer(rev, c->listening->post_accept_timeout);
 
     if (ngx_handle_read_event(rev, 0) != NGX_OK) {
@@ -383,6 +385,11 @@ ngx_http_wait_request_handler(ngx_event_
         return;
     }
 
+    if (c->close) {
+        ngx_http_close_connection(c);
+        return;
+    }
+
     hc = c->data;
     cscf = ngx_http_get_module_srv_conf(hc->conf_ctx, ngx_http_core_module);
 
@@ -432,6 +439,7 @@ ngx_http_wait_request_handler(ngx_event_
 
         if (!rev->timer_set) {
             ngx_add_timer(rev, c->listening->post_accept_timeout);
+            ngx_reusable_connection(c, 1);
         }
 
         if (ngx_handle_read_event(rev, 0) != NGX_OK) {
@@ -466,6 +474,8 @@ ngx_http_wait_request_handler(ngx_event_
 
     c->log->action = "reading client request line";
 
+    ngx_reusable_connection(c, 0);
+
     c->data = ngx_http_create_request(c);
     if (c->data == NULL) {
         ngx_http_close_connection(c);
@@ -611,6 +621,11 @@ ngx_http_ssl_handshake(ngx_event_t *rev)
         return;
     }
 
+    if (c->close) {
+        ngx_http_close_connection(c);
+        return;
+    }
+
     n = recv(c->fd, (char *) buf, 1, MSG_PEEK);
 
     err = ngx_socket_errno;
@@ -670,6 +685,8 @@ ngx_http_ssl_handshake(ngx_event_t *rev)
                     ngx_add_timer(rev, c->listening->post_accept_timeout);
                 }
 
+                ngx_reusable_connection(c, 0);
+
                 c->ssl->handler = ngx_http_ssl_handshake_handler;
                 return;
             }
@@ -714,6 +731,8 @@ ngx_http_ssl_handshake_handler(ngx_conne
         c->read->handler = ngx_http_wait_request_handler;
         /* STUB: epoll edge */ c->write->handler = ngx_http_empty_handler;
 
+        ngx_reusable_connection(c, 1);
+
         ngx_http_wait_request_handler(c->read);
 
         return;
